# TonysList

A minimalist Craigslist clone for small communities.

## Development History

The project was first started on August 13th, 2022 and one part or another of OrcasHub
has been under nearly constant development since. For the first two years Tony Grosinger
recorded a close estimate of his time spent on the project. By May 17th, 2024 he had
recorded 730 hours. After this point time tracking stopped, but development has of course continued.

## TODO

- Classifieds Features
  - Email subscriptions to a saved query
    - Setup [rebound](https://postmarkapp.com/rebound)
    - Use [message streams](https://postmarkapp.com/message-streams)
- Translations
  - probably using [go-i18n](https://github.com/nicksnyder/go-i18n/)

## Dependencies

There is a devcontainer for this project that will provide a working environment
for developing. If you wish to develop outside of the container please refer to the
devcontainer and production dockerfiles for the required dependencies.

## Developing

This site was originally bootstrapped by the wonderful [Pagoda starter
kit](https://github.com/mikestefanello/pagoda), however just about everything has
been changed and very little of Pagoda remains. It leverages the following
projects (not a complete list):

- [Alpine.js](https://alpinejs.dev/): Minimal js frontend framework
  - [Docs](https://alpinejs.dev/start-here)
- [TailwindCSS](https://tailwindcss.com/): CSS framework
  - [Docs](https://tailwindcss.com/docs)
  - [TailwindUI Components](https://tailwindui.com/components)
- [HTMX](https://htmx.org/): HTML over the wire framework
  - [Docs](https://htmx.org/docs/)
- [Echo](https://echo.labstack.com/): Web framework
  - [Docs](https://echo.labstack.com/guide/)
- [Postmark](https://postmarkapp.com)
  - [Docs](https://postmarkapp.com/manual)

### Getting Started

Launch the Docker container described in `.devcontainer` and mount this
directory at `/workspaces/tonyslist`. If you are using VS Code, it will probably
offer to do this for you automatically.

You can now start up the web server by running `make`.
