-- name: GetGroupMembers :many
SELECT u.*
FROM users u
JOIN user_groups ug ON ug.user_id = u.id
WHERE ug.group_id = ?;

-- name: GetGroupsForUserID :many
SELECT g.name FROM groups g
JOIN user_groups ug ON ug.group_id = g.id
WHERE ug.user_id = ?;

-- name: GetGroupByName :one
SELECT * FROM groups
WHERE name = ?
LIMIT 1;

-- name: GetGroupByID :one
SELECT * FROM groups
WHERE id = ?
LIMIT 1;

-- name: GetGroups :many
SELECT * FROM groups;

-- name: SearchGroups :many
SELECT * FROM groups
WHERE
    name LIKE ?;

-- name: CreateGroup :execlastid
INSERT INTO groups (
    name
) VALUES (
    ?
);

-- name: DeleteGroup :exec
-- DeleteGroup removes a group from the database. All dependent tables including
-- user_groups will cascade.
DELETE FROM groups
WHERE id = ?;
