// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.27.0
// source: groups.sql

package sqlc

import (
	"context"
)

const createGroup = `-- name: CreateGroup :execlastid
INSERT INTO groups (
    name
) VALUES (
    ?
)
`

func (q *Queries) CreateGroup(ctx context.Context, name string) (int64, error) {
	result, err := q.db.ExecContext(ctx, createGroup, name)
	if err != nil {
		return 0, err
	}
	return result.LastInsertId()
}

const deleteGroup = `-- name: DeleteGroup :exec
DELETE FROM groups
WHERE id = ?
`

// DeleteGroup removes a group from the database. All dependent tables including
// user_groups will cascade.
func (q *Queries) DeleteGroup(ctx context.Context, id int) error {
	_, err := q.db.ExecContext(ctx, deleteGroup, id)
	return err
}

const getGroupByID = `-- name: GetGroupByID :one
SELECT id, name FROM groups
WHERE id = ?
LIMIT 1
`

func (q *Queries) GetGroupByID(ctx context.Context, id int) (Group, error) {
	row := q.db.QueryRowContext(ctx, getGroupByID, id)
	var i Group
	err := row.Scan(&i.ID, &i.Name)
	return i, err
}

const getGroupByName = `-- name: GetGroupByName :one
SELECT id, name FROM groups
WHERE name = ?
LIMIT 1
`

func (q *Queries) GetGroupByName(ctx context.Context, name string) (Group, error) {
	row := q.db.QueryRowContext(ctx, getGroupByName, name)
	var i Group
	err := row.Scan(&i.ID, &i.Name)
	return i, err
}

const getGroupMembers = `-- name: GetGroupMembers :many
SELECT u.id, u.email, u.verified, u.created_at, u.name, u.stripe_customer_id, u.count_posts_created, u.count_events_created, u.count_logins, u.count_page_loads, u.last_login, u.count_bounced_emails, u.count_posts_response_emails, u.count_other_incoming_email, u.digest_marked_spam, u.admin_marked_spam, u.user_message_marked_spam, u.username
FROM users u
JOIN user_groups ug ON ug.user_id = u.id
WHERE ug.group_id = ?
`

func (q *Queries) GetGroupMembers(ctx context.Context, groupID int) ([]User, error) {
	rows, err := q.db.QueryContext(ctx, getGroupMembers, groupID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []User
	for rows.Next() {
		var i User
		if err := rows.Scan(
			&i.ID,
			&i.Email,
			&i.Verified,
			&i.CreatedAt,
			&i.Name,
			&i.StripeCustomerID,
			&i.CountPostsCreated,
			&i.CountEventsCreated,
			&i.CountLogins,
			&i.CountPageLoads,
			&i.LastLogin,
			&i.CountBouncedEmails,
			&i.CountPostsResponseEmails,
			&i.CountOtherIncomingEmail,
			&i.DigestMarkedSpam,
			&i.AdminMarkedSpam,
			&i.UserMessageMarkedSpam,
			&i.Username,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getGroups = `-- name: GetGroups :many
SELECT id, name FROM groups
`

func (q *Queries) GetGroups(ctx context.Context) ([]Group, error) {
	rows, err := q.db.QueryContext(ctx, getGroups)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Group
	for rows.Next() {
		var i Group
		if err := rows.Scan(&i.ID, &i.Name); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getGroupsForUserID = `-- name: GetGroupsForUserID :many
SELECT g.name FROM groups g
JOIN user_groups ug ON ug.group_id = g.id
WHERE ug.user_id = ?
`

func (q *Queries) GetGroupsForUserID(ctx context.Context, userID int) ([]string, error) {
	rows, err := q.db.QueryContext(ctx, getGroupsForUserID, userID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []string
	for rows.Next() {
		var name string
		if err := rows.Scan(&name); err != nil {
			return nil, err
		}
		items = append(items, name)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const searchGroups = `-- name: SearchGroups :many
SELECT id, name FROM groups
WHERE
    name LIKE ?
`

func (q *Queries) SearchGroups(ctx context.Context, name string) ([]Group, error) {
	rows, err := q.db.QueryContext(ctx, searchGroups, name)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Group
	for rows.Next() {
		var i Group
		if err := rows.Scan(&i.ID, &i.Name); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
