// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.27.0
// source: tags.sql

package sqlc

import (
	"context"
	"strings"

	"git.grosinger.net/tgrosinger/tonyslist/pkg/conv"
)

const createTag = `-- name: CreateTag :execlastid
INSERT INTO tags
  (name, restricted_group_id)
VALUES
  (?, ?)
`

type CreateTagParams struct {
	Name              string       `db:"name"`
	RestrictedGroupID conv.NullInt `db:"restricted_group_id"`
}

func (q *Queries) CreateTag(ctx context.Context, arg CreateTagParams) (int64, error) {
	result, err := q.db.ExecContext(ctx, createTag, arg.Name, arg.RestrictedGroupID)
	if err != nil {
		return 0, err
	}
	return result.LastInsertId()
}

const deleteTag = `-- name: DeleteTag :exec
DELETE FROM tags
WHERE id = ?
`

func (q *Queries) DeleteTag(ctx context.Context, id int) error {
	_, err := q.db.ExecContext(ctx, deleteTag, id)
	return err
}

const getTagByID = `-- name: GetTagByID :one
SELECT id, name, restricted_group_id FROM tags
WHERE id = ?
LIMIT 1
`

func (q *Queries) GetTagByID(ctx context.Context, id int) (Tag, error) {
	row := q.db.QueryRowContext(ctx, getTagByID, id)
	var i Tag
	err := row.Scan(&i.ID, &i.Name, &i.RestrictedGroupID)
	return i, err
}

const getTags = `-- name: GetTags :many
SELECT id, name, restricted_group_id FROM tags
`

func (q *Queries) GetTags(ctx context.Context) ([]Tag, error) {
	rows, err := q.db.QueryContext(ctx, getTags)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Tag
	for rows.Next() {
		var i Tag
		if err := rows.Scan(&i.ID, &i.Name, &i.RestrictedGroupID); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getTagsAllowedForUser = `-- name: GetTagsAllowedForUser :many
SELECT id, name, restricted_group_id FROM tags
WHERE
    restricted_group_id IS NULL
    OR restricted_group_id IN (SELECT groups.id FROM groups WHERE groups.name IN (/*SLICE:names*/?))
`

func (q *Queries) GetTagsAllowedForUser(ctx context.Context, names []string) ([]Tag, error) {
	query := getTagsAllowedForUser
	var queryParams []interface{}
	if len(names) > 0 {
		for _, v := range names {
			queryParams = append(queryParams, v)
		}
		query = strings.Replace(query, "/*SLICE:names*/?", strings.Repeat(",?", len(names))[1:], 1)
	} else {
		query = strings.Replace(query, "/*SLICE:names*/?", "NULL", 1)
	}
	rows, err := q.db.QueryContext(ctx, query, queryParams...)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Tag
	for rows.Next() {
		var i Tag
		if err := rows.Scan(&i.ID, &i.Name, &i.RestrictedGroupID); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
