package components

import (
	g "maragu.dev/gomponents"
	h "maragu.dev/gomponents/html"
)

func HtmxSearch(targetSelector, path string) g.Node {
	return h.Div(
		h.Class("mr-2 mt-2 w-full max-w-lg lg:max-w-xs"),
		SRLabel("search", "Search"),
		h.Div(
			h.Class("relative text-gray-400 focus-within:text-gray-600"),
			h.Div(
				h.Class("pointer-events-none absolute inset-y-0 left-0 flex items-center pl-1"),
				IconSolidSearch()),
			h.Input(
				h.ID("search"),
				HxGet(path),
				HxTarget(targetSelector),
				HxSwap("outerHTML"),
				HxTrigger("search, keyup changed delay:300ms"),
				HxSwap("this:replace"),
				h.Class("peer block w-full rounded-md border border-transparent bg-white py-2 pl-10 pr-3 leading-5 text-gray-900 placeholder-gray-500 focus:border-white focus:outline-none focus:ring-2 focus:ring-white focus:ring-offset-2 focus:ring-offset-indigo-600 sm:text-sm"),
				h.Placeholder("Search"),
				h.Type("search"),
				h.Name("search"))))
}
